unit CMain;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants, System.Messaging,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, FMX.StdCtrls,Androidapi.JNI.GraphicsContentViewText;

type
  TFormMain = class(TForm)
    btnRecord: TButton;
    lblStatus: TLabel;
    procedure btnRecordClick(Sender: TObject);
  private
    { Private declarations }
    FMessageSubscriptionID: Integer;
    procedure HandleActivityMessage(const Sender: TObject; const M: TMessage);
    function OnActivityResult(RequestCode, ResultCode: Integer; Data: JIntent): Boolean;
  public
    { Public declarations }
  end;

var
  FormMain: TFormMain;

implementation
uses Androidapi.JNI.Provider, Androidapi.JNI.App,Androidapi.JNI.Net, Androidapi.JNIBridge,
  Androidapi.Helpers,Androidapi.JNI.JavaTypes,Androidapi.JNI.Os;

{$R *.fmx}
{$R *.NmXhdpiPh.fmx ANDROID}

procedure TFormMain.btnRecordClick(Sender: TObject);
var
  takeVideoIntent:JIntent;
  videoUri:Jnet_Uri;
  AFile:JFile;
begin
  //
  FMessageSubscriptionID := TMessageManager.DefaultManager.SubscribeToMessage(TMessageResultNotification,
      HandleActivityMessage);
  takeVideoIntent := TJIntent.JavaClass.init(TJMediaStore.JavaClass.ACTION_VIDEO_CAPTURE);
  if (takeVideoIntent.resolveActivity(SharedActivityContext.getPackageManager()) <>nil) then
  begin
    //  startActivityForResult(takeVideoIntent, REQUEST_VIDEO_CAPTURE);
    AFile:=TJFile.JavaClass.init(StringToJString('/sdcard/Movies/record.mp4'));
    videoUri:=TJnet_Uri.JavaClass.fromFile(AFile);
    takeVideoIntent.putExtra(TJMediaStore.JavaClass.EXTRA_OUTPUT, TJParcelable.Wrap((videoUri as ILocalObject).GetObjectID));
    SharedActivity.startActivityForResult(takeVideoIntent, 9);
  end;
end;

procedure TFormMain.HandleActivityMessage(const Sender: TObject;
  const M: TMessage);
begin
  if M is TMessageResultNotification then
    OnActivityResult(TMessageResultNotification(M).RequestCode, TMessageResultNotification(M).ResultCode,
      TMessageResultNotification(M).Value);
end;

function TFormMain.OnActivityResult(RequestCode, ResultCode: Integer;
  Data: JIntent): Boolean;
var
  videoUri :Jnet_Uri;
begin
  Result := False;

  TMessageManager.DefaultManager.Unsubscribe(TMessageResultNotification, FMessageSubscriptionID);
  FMessageSubscriptionID := 0;

  if RequestCode = 9 then
  begin
    if ResultCode = TJActivity.JavaClass.RESULT_OK then
    begin
      TThread.Queue(nil, procedure
      begin
        lblStatus.Text:='record to /sdcard/Movies/record.mp4 ok';
        Invalidate;
      end);
//      if Assigned(Data) then
//      begin
//        videoUri:=data.getData;
//        //ShowMessage(JStringToString(videoUri.toString()));
//
//      end;
    end
    else if ResultCode = TJActivity.JavaClass.RESULT_CANCELED then
    begin
        TThread.Queue(nil, procedure
        begin
          lblStatus.Text:='record canceled';
          Invalidate;
        end);
    end;
    Result := True;
  end;
end;

end.
